<?php
class BP_User_Media_Template {
    var $current_picture = -1;
    var $picture_count;
    var $pictures;
    var $picture; //where the hell this initialized?

    var $in_the_loop;

    var $pag_page;
    var $pag_num;
    var $pag_links;
    var $total_picture_count;
    var $media_slug;

    function BP_User_Media_Template( $user_id_filter, $page, $per_page, $max, $media_type ) {
        global $bp;
        if ( !$user_id )
            $user_id = $bp->loggedin_user->id;
        $this->pag_page = isset( $_GET['fpage'] ) ? intval( $_GET['fpage'] ) : $page;
        $this->pag_num = isset( $_GET['num'] ) ? intval( $_GET['num'] ) : $per_page;

        if ( !$this->pictures = wp_cache_get( 'bp_pictures_for_user_' . $user_id, 'bp' ) ) {
            $this->pictures = bp_pictures_get_pictures_for_user( $user_id_filter, $media_type);
            $this->media_slug = $this->pictures['media_slug'];
            wp_cache_set( 'bp_pictures_for_user_' . $user_id, $this->pictures, 'bp' );
//          wp_cache_set($key, $data, $flag = '', $expire = 0)
        }

        if ( !$max )
            $this->total_picture_count = (int)$this->pictures['count'];
        else
            $this->total_picture_count = (int)$max;

        $this->pictures = array_slice( (array)$this->pictures['pictures'], intval( ( $this->pag_page - 1 ) * $this->pag_num), intval( $this->pag_num ) );

        if ( $max ) {
            if ( $max >= count($this->pictures) )
                $this->picture_count = count($this->pictures);
            else
                $this->picture_count = (int)$max;
        } else {
            $this->picture_count = count($this->pictures);
        }


                        $this->pag_links = paginate_links( array(
                'base' => add_query_arg( array('fpage'=> '%#%', 'num' => $this->pag_num) ),
                'format' => '',
                'total' => ceil(( $this->total_picture_count) / $this->pag_num),
                'current' => $this->pag_page,
                'prev_text' => '&laquo;',
                'next_text' => '&raquo;',
                'mid_size' => 1
        ));

//        $this->pag_links = paginate_links( array(
//                'base' => add_query_arg( 'fpage', '%#%' ),
//                'format' => '',
//                'total' => ceil($this->total_picture_count / $this->pag_num),
//                'current' => $this->pag_page,
//                'prev_text' => '&laquo;',
//                'next_text' => '&raquo;',
//                'mid_size' => 1
//        ));

//var_dump($this->total_picture_count);
    }

    function has_pictures() {
        if ( $this->picture_count )
            return true;

        return false;
    }

    function next_picture() {
        $this->current_picture++;
        $this->picture = $this->pictures[$this->current_picture];

        return $this->picture;
    }

    function rewind_pictures() {
        $this->current_picture = -1;
        if ( $this->picture_count > 0 ) {
            $this->picture = $this->pictures[0];
        }
    }

    function user_pictures() {
        if ( $this->current_picture + 1 < $this->picture_count ) {
            return true;
        } elseif ( $this->current_picture + 1 == $this->picture_count ) {
            do_action('loop_end');
            // Do some cleaning up after the loop
            $this->rewind_pictures();
        }

        $this->in_the_loop = false;
        return false;
    }

    function the_picture() {
        global $picture,$kaltura_validation_data,$picture1;
//        var_dump($picture);
        $this->in_the_loop = true;
        $picture = $this->next_picture();
        if ( 0 == $this->current_picture ) // loop has just started
            do_action('loop_start');
    }
}

function bp_has_media( $args = '' ) {
    global $pictures_template;
    $defaults = array(
            'user_id' => false,
            'per_page' => 8,
            'page' =>1,
            'max' => false,
            'scope'=> 'mediaall'
    );

    $r = wp_parse_args( $args, $defaults );
    extract( $r, EXTR_SKIP );

//    var_dump($args);
    $pictures_template = new BP_User_Media_Template( $user_id,$page, $per_page, $max,$scope );
//    var_dump($pictures_template);
    return $pictures_template->has_pictures();
}

function bp_pictures() {
    global $pictures_template;
//       var_dump($pictures_template->user_pictures());
    return $pictures_template->user_pictures();
}

function bp_the_picture() {
    global $pictures_template;
//        var_dump($pictures_template->the_picture());
    return $pictures_template->the_picture();
}
function is_media_exists($id) {
    global $wpdb,$bp;
    $qry = "SELECT id FROM {$bp->media->table_media_data} WHERE id='$id'";
//    var_dump($qry);
    $result = $wpdb->get_col();

    if($result)
        return true;
    else
        return false;
}

function bp_pictures_pagination_count() {
    global $bp, $pictures_template;

    $from_num = intval( ( $pictures_template->pag_page - 1 ) * $pictures_template->pag_num ) + 1;
    $to_num = ( $from_num + ( $pictures_template->pag_num - 1 ) > $pictures_template->total_picture_count ) ? $pictures_template->total_picture_count : $from_num + ( $pictures_template->pag_num - 1 ) ;

    echo sprintf( __( 'Viewing picture %d to %d (of %d pictures)', 'buddypress' ), $from_num, $to_num, $pictures_template->total_picture_count ); ?> &nbsp;
<img id="ajax-loader-pictures" src="<?php echo $bp->core->image_base ?>/ajax-loader.gif" height="7" alt="<?php _e( "Loading", "buddypress" ) ?>" style="display: none;" /><?php
}

function bp_pictures_pagination_links() {
    echo bp_get_pictures_pagination_links();
}
function bp_get_pictures_pagination_links() {
    global $pictures_template;

    return apply_filters( 'bp_get_pictures_pagination_links', $pictures_template->pag_links );
}

function bp_picture_title() {
    echo bp_get_picture_title();
}
function bp_media_rating() {
    echo bp_get_media_rating();
}
function bp_get_media_rating() {
    global $pictures_template,$single_pic_template;
//    var_dump($pictures_template->picture);
//    $rank = $pictures_template->picture->localrank;
     $view = $pictures_template->picture->localview;
     $tot_rank = $pictures_template->picture->local_tot_rank;
     $ctr_rank = $pictures_template->picture->local_rating_ctr;
     $rank.'a '.$view.' b '. $tot_rank.'c '.$ctr_rank;

    $local_entry = $pictures_template->picture->id;
    if($tot_rank==0 && ctr_rank ==0) {
        get_actual_rating($r,$local_entry);
    }else {
        try {
            $rating = $tot_rank / $ctr_rank;
            $r =  ceil($rating);
            get_actual_rating($r,$local_entry);
        }
        catch(Exception $e) {
            echo 'Error !!!';
        }
    }

//         echo $tot_rank .' aa '.$local_entry;
//    $e_id = $picture_template->picture;
    //$rating = $rank / $view;
    //$r =  ceil($rating);


}

function get_actual_rating($r,$local_entry) {
//    echo ($r);
//    echo ($local_entry);
    switch ($r) {
        case 0:

            echo '<div class="jquerystar">
                    <input name="star'.$local_entry.'" type="radio" value ="1" class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value ="2" class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value ="3" class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value ="4" class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value ="5" class="star {split:2}"/>
                    </div>';
            break;


        case 1:

            echo '<div class="jquerystar">
                    <input name="star'.$local_entry.'" type="radio" value ="1" class="star {split:2}" checked="checked"/>
                    <input name="star'.$local_entry.'" type="radio" value ="2" class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value ="3" class="star {split:2}" />
                    <input name="star'.$local_entry.'" type="radio" value ="4" class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value ="5" class="star {split:2}"/>
                    </div>';
            break;

        case 2:

            echo '<div class="jquerystar">
                    <input name="star'.$local_entry.'" type="radio" value = 1 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 2 class="star {split:2}" checked="checked"/>
                    <input name="star'.$local_entry.'" type="radio" value = 3 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 4 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 5 class="star {split:2}"/>
                    </div>';

            break;

        case 3:

            echo '<div class="jquerystar">
                    <input name="star'.$local_entry.'" type="radio" value = 1 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 2 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 3 class="star {split:2}" checked="checked"/>
                    <input name="star'.$local_entry.'" type="radio" value = 4 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 5 class="star {split:2}"/>
                    </div>';
            break;
        case 4:

            echo '<div class="jquerystar">
                    <input name="star'.$local_entry.'" type="radio" value = 1 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 2 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 3 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 4 class="star {split:2}" checked="checked"/>
                    <input name="star'.$local_entry.'" type="radio" value = 5 class="star {split:2}"/>
                    </div>';
            break;
        case 5:

            echo '<div class="jquerystar">
                    <input name="star'.$local_entry.'" type="radio" value = 1 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 2 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 3 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 4 class="star {split:2}"/>
                    <input name="star'.$local_entry.'" type="radio" value = 5 class="star {split:2}" checked="checked"/>
                    </div>';
            break;
        default:
            echo '<div class = "jquerystar"> Be 1st to rate it </div>';

    }

}
function bp_get_picture_title() {
    global $pictures_template;

    return apply_filters( 'bp_get_picture_title',substr($pictures_template->picture->name,0,20).'...');
}


function bp_picture_description() {
    echo bp_get_picture_description;
}
function bp_get_picture_description() {
    global $pictures_template;

    return apply_filters( 'bp_get_picture_description', $pictures_template->picture->description);
}


function bp_picture_small_link() {
    global $bp,$pictures_template;
//    var_dump($pictures_template);
    echo $pictures_template->picture->thumbnailUrl;

}

/* Functions for Single picture View
 *
*/



function bp_picture_view_link() {
    echo bp_get_picture_view_link();
}
function bp_get_picture_view_link() {
    global $pictures_template, $bp;//$pictures_template->picture->id shud point to the id and not entry_id
//    var_dump($pictures_template);
//    var_dump($pictures_template->media_slug);
//    echo $scope;
//    echo $pictures_template->media_slug;
    return $bp->displayed_user->domain . $bp->media->slug .'/'. $pictures_template->media_slug .'/'. $pictures_template->picture->db_id ;

//    var_dump($bp);
//    if(!$scope == ''){
//     return apply_filters( 'bp_get_picture_view_link', $bp->displayed_user->domain . $bp->media->slug .'/'.$scope.'/'.$pictures_template->picture->db_id);
//    }
//     else{
//         return apply_filters( 'bp_get_picture_view_link', $bp->displayed_user->domain . $bp->media->slug .'/'.$pictures_template->picture->db_id);
//     }

}

function bp_picture_view() {
    global $bp,$single_pic_template;
//    echo site_url().$single_pic_template->pic_mid_path;
//        var_dump($single_pic_template->pic_mid_path);
    return $single_pic_template->pic_mid_path;
}


function bp_media_user_rated() {
    global $bp,$single_pic_template,$pictures_template;
//    print_r($single_pic_template);
    $rating = $single_pic_template->tot_rating;
    $views =  $single_pic_template->rating_ctr;

    if ($rating ==0 && $views==0) {
        get_actual_rating($r=0,$local_entry);
    }
    else {
//    echo  $rating . $views;
        try {
            $rating =  $rating/$views;
            $r = ceil($rating);
            get_actual_rating($r,$local_entry);
        }
        catch(Exception $e) {
            $e. " is error";
        }
    }
}

function get_media_data() {
    global $bp,$single_pic_template;
//    var_dump($single_pic_template);
    $media_type =$bp->current_action;
//    var_dump($media_type);
    if($single_pic_template->picture_id == -9999)
        echo 'This file has been deleted from server due to some reasons ....';
    else {


        switch($single_pic_template->media_type) {
            case '1':
                return bp_rt_media_video_library();
                break;
            case '2':
                return '<img src='. bp_picture_view().' />
                        <input id="current-media-id" type = "hidden" value = "'.$bp->action_variables[0].'"/>
                        <input id="current-user-id" type = "hidden" value = "'.$bp->loggedin_user->id.'"/>
                        ';
                break;
            case '5':
                return bp_rt_media_video_library();
                break;
        }
    }



//    echo site_url().$single_pic_template->pic_mid_path;
//    echo $single_pic_template->pic_mid_path;
//    echo 'Current Action';
    //var_dump($bp->current_action);

//   return html content as per current action video = flash
}

function bp_rt_media_video_library() {
    global $bp,$kaltura_validation_data,$single_pic_template;
    $partner_id = $kaltura_validation_data['partner_id'];
    $kaltura_url = $kaltura_validation_data['config']->serviceUrl;
    /*
     * Get the userwise media content.
    */

    ?>
<input id="current-media-id" type = "hidden" value = "<?php echo $bp->action_variables[0]?>"/>
<input id="current-user-id" type = "hidden" value = "<?php echo $bp->loggedin_user->id?>"/>
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/swfobject/2.2/swfobject.js"></script>
<div id="asdf1">
    <object
        name="mykdp"
        id="mykdp"
        type="application/x-shockwave-flash"
        allowScriptAccess="always"
        allowNetworking="all"
        allowFullScreen="true"
        height="335" width="400"
        data="<?php echo $kaltura_url ?>/index.php/kwidget/cache_st/1253598756/wid/_<?php echo $partner_id?>/uiconf_id/48410/entry_id/<?php echo $single_pic_template->picture_id?>">

        <param name="allowScriptAccess" value="always" />
        <param name="allowNetworking" value="all" />
        <param name="allowFullScreen" value="true" />
        <param name="bgcolor" value="#000000" />
        <param name="movie" value="<?php echo $kaltura_url ?>/index.php/kwidget/cache_st/1253598756/wid/_<?php echo $partner_id?>/uiconf_id/48410/entry_id/<?php echo $single_pic_template->picture_id?>"/>
        <param name="flashVars" value=""/>
    </object>
</div>

    <?php
}




function bp_single_picture_title() {
    echo bp_get_single_picture_title();
}
function bp_get_single_picture_title() {
    global $bp,$single_pic_template,$pictures_template;
//    var_dump($single_pic_template);
    return apply_filters( 'bp_get_single_picture_title', $single_pic_template->title);
}

function bp_single_media_id() {
    return bp_get_single_media_id();
}
function bp_get_single_media_id() {
    global $bp,$single_pic_template,$pictures_template;
//    var_dump($single_pic_template);
    return apply_filters( 'bp_get_single_media_id', $single_pic_template->id);
}


function bp_single_picture_description() {
    echo bp_get_single_picture_description();
}
function bp_get_single_picture_description() {
    global $single_pic_template;
//    var_dump($single_pic_template->description);
    if($single_pic_template->description == '')
        $single_pic_template->description = 'You can add Description here...';

    return apply_filters( 'bp_get_single_picture_description', $single_pic_template->description);
}

function bp_single_pic_exist() {
    global $bp,$single_pic_template;

    if (!$bp->action_variables[0])
        return flase;

    $pic_id=$bp->action_variables[0];
    //   var_dump($pic_id);
    $single_pic_template=new BP_Media_Picture($pic_id);
//    var_dump($single_pic_template);
    if (!$single_pic_template->id)
        return false;

    return true;
}


function bp_single_pic_delete_link() {
    echo bp_get_single_pic_delete_link();
}
function bp_get_single_pic_delete_link() {
    global $single_pic_template, $bp;
//    echo 'DD'. $bp->current_component.'DD';
    $pic_id = $single_pic_template->id;
    if ( isMediaOwner($pic_id) ) {

        if ($bp->current_component == $bp->media->slug) {
//           echo
            return apply_filters( 'bp_get_single_pic_delete_link',
                    '<a id ="yes" class="del" href="'
                    . wp_nonce_url( $bp->root_domain.'/'
                    . $bp->media->slug . '/'.$bp->current_action.'/delete-picture-server/'
                    . $single_pic_template->id, 'bp_single_pic_delete_link_server' ) . '">'
                    . Yes . '</a> ' );
        }
    }
}

function bp_single_pic_delete_link_local() {
    echo bp_get_single_pic_delete_link_local_copy();
}
function bp_get_single_pic_delete_link_local_copy() {
    global $single_pic_template, $bp;
    $pic_id = $single_pic_template->id;
    if ( isMediaOwner($pic_id) ) {
        if ($bp->current_component == $bp->media->slug) {
            return apply_filters( 'bp_get_single_pic_delete_link_local',
                    '<a id ="no" class="del" href="' . wp_nonce_url( $bp->root_domain.'/' . $bp->media->slug . '/'.$bp->current_action.'/delete-picture/'
                    . $single_pic_template->id, 'bp_single_pic_delete_link' ) . '">'
                    . No . '</a> ' );
        }
    }
}


function bp_single_pic_check_owner() {
    global $bp,$single_pic_template;
//    var_dump($bp->displayed_user->id );
//    var_dump($single_pic_template->user_id);
    if ($bp->displayed_user->id == $single_pic_template->user_id)
        return true;

    return false;
}

function bp_single_pic_id() {
    global $single_pic_template;

    return $single_pic_template->id;
}

function bp_get_picture_permalink( $picture_id = false ) {
    global $bp;

    return apply_filters( 'bp_get_picture_permalink', $bp->displayed_user->domain . $bp->media->slug . '/picture/' . $picture_id );
}



/*
 * Wire Functions
*/

function bp_pic_wire_get_post_list( $item_id = null, $title = null, $empty_message = null, $can_post = true, $show_email_notify = false ) {
    global $bp_item_id, $bp_wire_header, $bp_wire_msg, $bp_wire_can_post, $bp_wire_show_email_notify;

    if ( !$item_id )
        return false;

    if ( !$message )
        $empty_message = __("There are currently no wire posts.", 'buddypress');

    if ( !$title )
        $title = __('Wire', 'buddypress');

    /* Pass them as globals, using the same name doesn't work. */
    $bp_item_id = $item_id;
    $bp_wire_header = $title;
    $bp_wire_msg = $empty_message;
    $bp_wire_can_post = $can_post;
    $bp_wire_show_email_notify = $show_email_notify;

    load_template( TEMPLATEPATH . '/media/post-list.php' );
}

function bp_media_wire_get_post_form() {
    global $wire_posts_template;

    if ( is_user_logged_in() && $wire_posts_template->can_post )
        load_template( TEMPLATEPATH . '/media/post-form.php' );
}

function bp_media_wire_get_action() {
    echo bp_get_picture_wire_get_action();
}
function bp_get_picture_wire_get_action() {
    global $bp;

    if ( empty( $bp->current_item ) )
        $uri = $bp->current_action;
    else
        $uri = $bp->current_item;

    if ( $bp->current_component == $bp->wire->slug || $bp->current_component == $bp->profile->slug ) {
        return apply_filters( 'bp_get_picture_wire_get_action', $bp->displayed_user->domain . $bp->wire->slug . '/post/' );
    } else if ($bp->current_component == $bp->media->slug) {
        global $single_pic_template;
        return apply_filters( 'bp_get_picture_wire_get_action', $bp->displayed_user->domain . $bp->media->slug . '/picture/post-wire/' );
    } else {
        return apply_filters( 'bp_get_picture_wire_get_action', site_url() . '/' . $bp->{$bp->current_component}->slug . '/' . $uri . '/' . $bp->wire->slug . '/post/' );
    }
}


function bp_media_wire_delete_link() {
    echo bp_get_picture_wire_delete_link();
}
function bp_get_picture_wire_delete_link() {
    global $wire_posts_template, $bp;

    if ( empty( $bp->current_item ) )
        $uri = $bp->current_action;
    else
        $uri = $bp->current_item;

    if ( ( $wire_posts_template->wire_post->user_id == $bp->loggedin_user->id ) || $bp->is_item_admin || is_site_admin() ) {
        if ( $bp->wire->slug == $bp->current_component || $bp->profile->slug == $bp->current_component ) {
            return apply_filters( 'bp_get_picture_wire_delete_link', '<a href="' . wp_nonce_url( $bp->displayed_user->domain . $bp->wire->slug . '/delete/' . $wire_posts_template->wire_post->id, 'bp_media_wire_delete_link' ) . '">[' . __('Delete', 'buddypress') . ']</a>' );
        } else if ($bp->current_component == $bp->media->slug) {
            global $single_pic_template;
            return apply_filters( 'bp_get_picture_wire_delete_link', '<a href="' . wp_nonce_url( $bp->displayed_user->domain . $bp->media->slug . '/picture/delete-wire/' . $wire_posts_template->wire_post->id, 'bp_media_wire_delete_link' ) . '">[' . __('Delete', 'buddypress') . ']</a>' );
        } else {
            return apply_filters( 'bp_get_picture_wire_delete_link', '<a href="' . wp_nonce_url( site_url( $bp->{$bp->current_component}->slug . '/' . $uri . '/wire/delete/' . $wire_posts_template->wire_post->id ), 'bp_media_wire_delete_link' ) . '">[' . __('Delete', 'buddypress') . ']</a>' );
        }
    }
}

// Check if pic owner

function isMediaOwner($picture_id) {
    global $bp,$wpdb;
    $user_id = $wpdb->get_var("SELECT user_id from {$bp->media->table_media_data} WHERE ID = {$picture_id} ");
    if($user_id == $bp->loggedin_user->id)
        return true;
    else
        return false;
}

/*
 * Function for Next and Previous Picture
*/
function next_picture_link($format='%link &raquo;', $link='%title') {
    adjacent_picture_link($format, $link, true);
}

function previous_picture_link($format='&laquo; %link', $link='%title') {
    adjacent_picture_link($format, $link, false);
}
function adjacent_picture_link($format, $link, $previous = true) {
    $picture = get_adjacent_picture($previous);
    if ( !$picture->id )
        return;
    $title = $picture->title;

    if ( empty($picture->title) )
        $title = $previous ? __('Previous') : __('Next');
    $title = $title;
    $string = '<a href="'.$picture->id.'">';
    $link = str_replace('%title', $title, $link);
    $link = $string . $link . '</a>';
    $format = str_replace('%link', $link, $format);
    $adjacent = $previous ? 'previous' : 'next';
    echo apply_filters( "picture_link", $format, $link );
}//function ends


function set_media_rating($rating,$id) {
    global $wpdb, $bp;
//$bp->media->table_name_wire = $wpdb->base_prefix . 'bp_media_wire';
    $bp->media->table_media_data = $wpdb->base_prefix . 'bp_media_data';
    $wpdb->query("UPDATE {$bp->media->table_media_data} SET rating = rating + {$rating}, views = views + 1  WHERE ID = {$id} ");
}

function get_media_rating() {
    global $wpdb, $bp;

    $id = $bp->action_variables[0];

    $bp->media->table_media_data = $wpdb->base_prefix . 'bp_media_data';
    $view = $wpdb->get_var("SELECT views from {$bp->media->table_media_data} WHERE ID = {$id} ");

    echo "Views : " .'<span class="view">'. $view.'</span>';
}

//bp_media_title_action

//new functions for bp 1.2 : Kapil
function bp_media_locate_template( $template_names, $load = false ) {
    if ( !is_array( $template_names ) )
        return '';
    $located = '';
    foreach($template_names as $template_name) {

        // split template name at the slashes
        $paths = explode( '/', $template_name );

        // only filter templates names that match our unique starting path
        if ( !empty( $paths[0] ) && 'media' == $paths[0] ) {

            $style_path = STYLESHEETPATH . '/' . $template_name;
            $plugin_path = BP_MEDIA_PLUGIN_DIR . "/themes/{$template_name}";

            if ( file_exists( $style_path )) {
                $located = $style_path;
                break;
            } else if ( file_exists( $plugin_path ) ) {
                $located = $plugin_path;
                break;
            }
        }
    }
    if ($load && '' != $located)
        load_template($located);
    return $located;
}

function bp_media_filter_template( $located_template, $template_names ) {
    // template already located, skip
//    var_dump('bp_media_filter_template called',$located_template,$template_names);
    if ( !empty( $located_template ) )
        return $located_template;
    // only filter for our component
    if ( $bp->current_component == $bp->media->slug ) {
        return bp_media_locate_template( $template_names );
    }
    return '';
}
add_filter( 'bp_located_template', 'bp_media_filter_template', 10, 2 );

function bp_media_load_template( $template ) {
//    var_dump($template);
    bp_core_load_template( $template );
}
function bp_is_user_media() {
    global $bp;
//        echo'TNAGF'. $bp->current_component;
    if ( BP_MEDIA_SLUG == $bp->current_component )
        return true;

    return false;
}

function bp_media_enqueue_url($file) {
    // split template name at the slashes
//        echo 'banf';
    $stylesheet_path = get_stylesheet_directory_uri();
    $suffix = explode($stylesheet_path,$file);

    $suffix_str=$suffix[1];
//        echo $suffix_str;
    $file_path_to_check = BP_MEDIA_PLUGIN_DIR . '/theme'.$suffix_str;
    $file_url_to_return = BP_MEDIA_PLUGIN_URL . '/theme'.$suffix_str;

    if ( file_exists($file)) {
        return $file;
    }elseif ( file_exists($file_path_to_check)) {
        return $file_url_to_return;
    }
}
add_filter( 'bp_media_enqueue_url', 'bp_media_enqueue_url' );
function get_media_views() {
    global $wpdb, $bp;
    $id = $bp->action_variables[0];
//    echo $id;
    $bp->media->table_media_data = $wpdb->base_prefix . 'bp_media_data';
    $view = $wpdb->get_var("SELECT views from {$bp->media->table_media_data} WHERE ID = {$id} ");
    echo "Views : " .'<span class="view">'. ++$view .'</span>';
}

function bp_get_photo_count() {
    global $wpdb,$bp;
    $u_id = $bp->loggedin_user->id;
    if($u_id == 0)
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data} WHERE media_type = 2 ");
    else
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data} WHERE media_type = 2 ");
    return $pic_count;
}

function bp_get_audio_count() {
    global $wpdb,$bp;
    $u_id = $bp->loggedin_user->id;
    if ($u_id == 0)
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data} WHERE media_type = 5 ");
    else
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data} WHERE media_type = 5 ");
    return $pic_count;
}

function bp_get_video_count() {
    global $wpdb,$bp;
    $u_id = $bp->loggedin_user->id;
    if($u_id == 0)
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data} WHERE media_type = 1 ");
    else
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data} WHERE media_type = 1 ");
    return $pic_count;
}
function bp_get_media_count() {
    global $wpdb,$bp;
    $u_id = $bp->loggedin_user->id;

    if($u_id == 0)
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data}");
    else
        $pic_count = $wpdb->get_var("SELECT count(id) from {$bp->media->table_media_data} ");
    return $pic_count;
}

function is_kaltura_configured() {
    if(get_site_option('bp_rt_kaltura_secret') && get_site_option(bp_rt_kaltura_admin_secret)){
//        var_dump(get_site_option('bp_rt_kaltura_secret'));
        return true;
    }
    else
        return false;

}
?>